#ifndef ENDIAN_H
#define ENDIAN_H

#include <stdint.h>

namespace endian {
    
    // True if this machine is little endian
    bool isLittle();
    
    // Swaps the endianness of a int32_t and returns the result
    int32_t swap_int32_t(int32_t);
    
    // Gets the most significant byte if which is 0, second most significant
    // if which is 1 and so on.
    char &getByteFrom_int32_t(int32_t source, int which);
};

#endif
