#ifndef EVENTRECIEVER_H
#define EVENTRECIEVER_H

class EventReciever {
public:
    
    // Enum returned by event methods.  Heres what each value means:
    // OK   - Do nothing
    // QUIT - End the current dialog
    enum Action { OK, QUIT };
    
protected:
    
    EventReciever() {}
    virtual ~EventReciever() {}
    
    // Called when this widget has focus and a key is pressed.
    //
    // Returns the action to be taken, see the enum Action for a better description.
    virtual Action onKey(int) { return OK; }
    
    // Called when this widget gains focus
    //
    // Returns the action to be taken, see the enum Action for a better description.
    virtual Action onFocus() { return OK; }
    
    // Called when this widget loses focus
    //
    // Returns the action to be taken, see the enum Action for a better description.
    virtual Action onUnfocus() { return OK; }
    
    // Called when this widget has the mouse hovering over it
    //
    // Returns the action to be taken, see the enum Action for a better description.
    virtual Action onHover() { return OK; }
    
    // Called when the mouse leaves this widget
    //
    // Returns the action to be taken, see the enum Action for a better description.
    virtual Action onLeave() { return OK; }
    
    // Called when this widget is clicked
    //
    // Returns the action to be taken, see the enum Action for a better description.
    virtual Action onClick() { return OK; }
    
    // Called when the mouse button has been released on top of this widget
    //
    // Returns the action to be taken, see the enum Action for a better description.
    virtual Action onRelease() { return OK; }
    
    // Called when nothing else is happening
    //
    // Returns the action to be taken, see the enum Action for a better description.
    virtual Action onIdle() { return OK; }
    
    /* Reciever methods.  These methods wrap events so that base classes can access
     * them before the child class sees them.
     */
    
    virtual Action sendKey(int key) { return onKey(key); }
    virtual Action sendFocus() { return onFocus(); }
    virtual Action sendUnfocus() { return onUnfocus(); }
    virtual Action sendHover() { return onHover(); }
    virtual Action sendLeave() { return onLeave(); }
    virtual Action sendClick() { return onClick(); }
    virtual Action sendRelease() { return onRelease(); }
    virtual Action sendIdle() { return onIdle(); }
};

class EventRecieverAsync {
public:
    
    EventRecieverAsync();
    virtual ~EventRecieverAsync() {}
    
    virtual void onKey(int);
    virtual void onFocus();
    virtual void onUnfocus();
    virtual void onHover();
    virtual void onLeave();
    virtual void onClick();
    virtual void onRelease();
    virtual void onIdle();
    
    bool onKeyAsync(int&);
    bool onFocusAsync();
    bool onUnfocusAsync();
    bool onHoverAsync();
    bool onLeaveAsync();
    bool onClickAsync();
    bool onReleaseAsync();
    bool onIdleAsync();
    
private:
    
    bool keyEvent;
    int keyEventParm;
    bool focusEvent;
    bool unfocusEvent;
    bool hoverEvent;
    bool leaveEvent;
    bool clickEvent;
    bool releaseEvent;
    bool idleEvent;
};

#endif
