#ifndef GAMEPLAY_H
#define GAMEPLAY_H

#include "gui.h"

class Gameplay : public GuiState {
public:
    
    // Loads the game given the already loaded scene and in mode 1 or 2.
    //
    // todo: Specify two constructors, one for loading scene from file and
    // one for loading scene from datafile.  Once thats done remove this
    // lower-level ctor.
    Gameplay();
    virtual ~Gameplay();
    
    // Returns the code passed to the instigaiting function.
    // see gui.h for a description.
    virtual int getReturnCode();
    
    // Draws the game to the screen
    virtual void draw();
    
    // Called at a constant rate of about 50 times a second
    // see gui.h for a description.
    virtual Options think(Gui &caller);
    
    // Recieve frames per second
    virtual void fps(int fps) { currentFPS = fps; }

private:
    
    int currentFPS;
};

#endif
