#ifndef GUIWINDOW_H
#define GUIWINDOW_H

#include "bitmap.h"
#include "animation.h"

// Helper class for drawing a gui window and a scrolling background
class GuiWindow {
public:
    
    GuiWindow(float x = 0, float y = 0, int w = 0, int h = 0);
    
    void drawBackground(int scroll, const Tint &tint = Tint());
    void drawForeground(const std::string &title, bool widthGradient = true, const Tint &tint = Tint());
    
    float x, y;
    int w, h;
    
private:
    
    animation background, hwall, vwall, corner;
    animation ltitle, ctitle, rtitle;
};

#endif
