#ifndef ITEMS_H
#define ITEMS_H

#include <string>
#include <map>

// Maintins properties for all items given the item's unique id number
class Items {
public:
    
    // Loads the item database from the filename suggested by the filename
    // parameter.
    void load(const std::string &filename);
    
    // Properties of an item
    struct Item {
        int cost;
        int inventorySize;
        std::string name, descr;
        
        Item(): cost(0), inventorySize(0) {}
    };
    
    // Item ID as the Key, item properties as the value
    std::map<unsigned int, Item> items;
    
};

#endif
