#ifndef MUTEX_H
#define MUTEX_H

#ifdef WIN32
#ifdef ALLEGRO_H
#include <winalleg.h>
#else
#include <windows.h>
#endif
#else
#include <pthread.h>
#endif

class Mutex {
public:
    
    Mutex();
    ~Mutex();
    
    // Waits for the Mutex to be unlocked, locks it again
    // and returns.
    void lock();
    
    // Tries to lock the mutex, returning true if successful and false
    // if the Mutex is already locked.
    bool tryToLock();
    
    // Unlocks the Mutex that was previously locked using either lock
    // or a successfull call to tryTolock.
    void unlock();
    
private:
    
#ifdef WIN32
    HANDLE mutex;
#else
    pthread_mutex_t pthread_mutex;
#endif
};

#endif
