#ifndef PERSON_H
#define PERSON_H

#include "terminal.h"

class Person {
public:
    Person();
    ~Person();
    
    /// Called by a train to tell the Person that he has reached a new city
    /// @returns true if the Person has gotten off the train, false if he stays on
    bool unload(unsigned int city, CityLink next_route);
    /// Called by a train to tell Persons to get on
    /// @returns true if the Person has gotten on the train
    bool poll_train(unsigned int train, CityLink route);
    /// Called to calculate the next step to reach the destination
    void recalculate_step();
    
    /// My current location, if I am inside a city
    unsigned int current_city;
    /// The train I am on, if I am on one
    unsigned int current_train;
    /// The next step in getting to that destination
    CityLink next_step;
    /// My current destination
    unsigned int destination;
};

#endif
