#ifndef RESOURCES_H
#define RESOURCES_H

#include <string>
#include <map>

// Maintains information about a resource given its type id number
class Resources {
public:
    
    // Loads the resources database from the filename suggested by the filename
    // parameter.
    void load(const std::string &filename);
    
    // Properties of a given type of resource
    struct Resource {
        std::string name, descr;
    };
    
    // Resource type ID as the Key, resource properties as the Value
    std::map<unsigned int, Resource> resources;
};

#endif
