#ifndef TIMER_H
#define TIMER_H

#ifndef WIN32
#include <sys/time.h>
#endif

extern class Timer {
public:
    
    typedef unsigned int time_t;
    
private:
    
#ifdef WIN32
    unsigned long long startTime;
    unsigned long long currentTime;
#else
    timeval startTime;
    timeval currentTime;
#endif
    
public:
    
    Timer();
    
    time_t usecs();
    time_t msecs();
    time_t secs();
    
}timer;

#endif
