#ifndef USER_H
#define USER_H

#include <string>
#include <map>
#include <stdint.h>

class User {
public:
    
    // Position in world.
    int x, y;
    
    // Sets the password
    void setPass(const std::string &pass);
    
    // Checks if the password is correct
    bool checkPass(const std::string &pass);
    
    // Sets the username to a lowercase version of the parameter.
    void setUsername(std::string username);
    
    // Checks to see if a lowercase version of the parameter matches username.
    bool checkUsername(std::string username);
    
    // The User's username
    std::string username;
    
    uint32_t password;
    
    // Attempts to use an item.  item specifies the item's id to try to use.
    // count specifies how many of the item to take.
    // Returns how many items were actually used (ie 0 if there are none of the
    // item left).
    int useItem(unsigned int item, int count = 1);
    
    // Attempts to give the User an item.  item specifies the item's id to try
    // and give the User.  count specifies how many to give it.
    // Returns how many items it actually got (ie 0 if the inventory is full).
    int giveItem(unsigned int item, int count = 1);
    
    // The users inventory, Key is the item type, Value is number of said item
    // in inventory.
    typedef std::map<unsigned int, int> Items;
    Items items;
    
    // Returns the number of inventory spaces left in inventory.
    int getItemSpace();
};

#endif
