#ifndef WIDGETS_LOCALHIGHSCORE_H
#define WIDGETS_LOCALHIGHSCORE_H

#include "widget.h"
#include "animation.h"
#include <vector>

namespace widgets {
    
    class LocalHighscore : public Widget {
    public:
        
        LocalHighscore();
        virtual ~LocalHighscore() { }
        
        // attributes can contain the following keys:
        //  none
        
        // Called whenever the object needs to draw itself to the screen.
        // The first two parameters specify the upper lefthand corner of the
        // screen and all widgets should draw to x + xstart and y + ystart.
        virtual void draw(int x, int y, const Tint &tint = Tint());
        
        virtual void load();
        
        struct Score {
            std::string name;
            int stars, score;
        };
        
    private:
        
        animation star;
        
        std::vector<Score> scores;
    };
}

#endif
