#include "font.h"
#include "log.h"
#include "conf.h"
#include "software.h"
#include <sstream>
using namespace std;

int FontRenderer::load(const string &objname, datafile_t *datafile)
{
    return 1;
    letters.clear();
    
    BITMAP *bmp;
    
    for(char i = 0; i < 0x7f; i++) {
        
        ostringstream os;
        
        os << objname << i;
        if(isupper(i))
            os << "U";
        bmp = (BITMAP*)datafile->loadfind(os.str());
        
        if(bmp)
            letters[i] = new Bitmap(bmp);
    }
    
    return letters.size();
}

void FontRenderer::startLoad(const string &objname, datafile_t *datafile)
{
    return;
    letters.clear();
    loadStepPosition = 0;
    this->objname = objname;
    datf = datafile;
}

int FontRenderer::loadStep()
{
    return 1;
    ostringstream os;
    BITMAP *bmp;
        
    os << objname << loadStepPosition;
    if(isupper(loadStepPosition))
        os << "U";
    bmp = (BITMAP*)datf->loadfind(os.str());
        
    if(bmp)
        letters[loadStepPosition] = new Bitmap(bmp);
    
    if(++loadStepPosition < 0x7f)
        return -1;
    
    return letters.size();
}

void FontRenderer::unload()
{
    return;
    for(map<char, Bitmap*>::iterator itr = letters.begin(); itr != letters.end(); ++itr) {
        
        delete itr->second;
    }
    
    letters.clear();
}

FontRenderer::~FontRenderer()
{
    unload();
}

void FontRenderer::draw(const char letter, int x, int y, const Tint &tint)
{
    map<char, Bitmap*>::iterator loc = letters.find(letter);
    
    if(loc != letters.end())
        loc->second->blitToScreen(x, y, tint);
}

void FontRenderer::drawString(const string &str, int x, int y, const Tint &tint)
{
    ASSERT(globalConfInstance->getRenderingMode() == Conf::SOFTWARE);
    textout_ex(softwareRenderer.screen, font, str.c_str(), x, y, makecol((int) (255 * tint.r), (int) (255 * tint.g), (int) (255 * tint.b)), -1);
    return;
    for(string::const_iterator itr = str.begin(); itr != str.end(); ++itr) {
        
        draw(*itr, x, y, tint);
        
        x += width(*itr);
    }
}

int FontRenderer::height()
{
    return text_height(font);
    map<char, Bitmap*>::iterator loc = letters.begin();
    
    if(loc != letters.end())
        return loc->second->geth();
    
    return 0;
}

int FontRenderer::width(const char letter)
{
    char temp[] = " ";
    temp[0] = letter;
    return text_length(font, temp);
    map<char, Bitmap*>::iterator loc = letters.find(letter);
    
    if(loc != letters.end())
        return loc->second->getw();
    
    return 0;
}

int FontRenderer::stringWidth(const string &str)
{
    int ret = 0;
    
    for(string::const_iterator itr = str.begin(); itr != str.end(); ++itr) {
        
        ret += width(*itr);
    }
    
    return ret;
}
