#include "items.h"
#include <log.h>
#include <fstream>
#include <sstream>
using namespace std;

void Items::load(const string &filename)
{
    items.clear();
    
    string line, str;
    
    ifstream in(filename.c_str());
    
    getline(in, line);
    
    if(line.find("itemDb") != 0)
        throw "Invalid itemDb file";
    
    unsigned int i = line.find("v");
    
    if(i == string::npos)
        throw "Unable to find version number in itemDb file";
    
    int ver = 0;
    
    istringstream verss(line.substr(i));
    
    verss.ignore();
    
    verss >> ver;
    
    if(ver != 1)
        throw "Invalid version number for itemDb file";
    
    while(in.good()) {
        
        getline(in, line);
        
        istringstream data(line);
        
        unsigned int id = 0;
        
        data >> id;
        
        if(id) {
            
            Item &item = items[id];
            
            data >> item.cost;
            data >> item.inventorySize;
            data >> item.name;
            
            while(data.good()) {
                
                data >> str;
                item.descr += str + " ";
            }
        }
    }
    
    out << "Loaded itemDb, items: " << items.size() << "\n";
}
