#include "person.h"
#include "log.h"
#include "world.h"
using namespace std;

Person::Person()
    : current_city(0), current_train(0), destination(0)
{
}

Person::~Person()
{
}

bool Person::unload(unsigned int city, CityLink next_route)
{
    if(destination == city)
    {
        current_city = city;
        current_train = 0;
        return true;
    }
    if(next_step.cityA == city || next_step.cityB == city)
    {
        recalculate_step();
        unsigned int other_city = next_route.cityA;
        if(other_city == city)
            other_city = next_step.cityB;
        if(next_step.cityA == other_city || next_step.cityB == other_city)
            return false;
    }
    current_city = city;
    current_train = 0;
    return true;
}

bool Person::poll_train(unsigned int train, CityLink route)
{
    unsigned int other_city = route.cityA;
    if(other_city == current_city)
        other_city = route.cityB;
    if(next_step.cityA == other_city || next_step.cityB == other_city)
    {
        current_city = 0;
        current_train = train;
        return true;
    }
    return false;
}

void Person::recalculate_step()
{
    if(current_city == destination)
    {
        out << "NPC reached destination\n";
        while(1)
        {
            map<unsigned int, City>::iterator next_city = world.cities.lower_bound(destination);
            if(next_city == world.cities.end())
                destination = 0;
            else
                destination = next_city->first;
                
            vector<CityLink> exits;
            for(map<int, unsigned int>::iterator i = world.cities[current_city].terminals.begin(); i != world.cities[current_city].terminals.end(); i++)
                world.terminals[i->second].list_exits(exits);
            for(vector<CityLink>::iterator i = exits.begin(); i != exits.end();)
            {
                if((i->cityA == current_city && i->cityB == destination) || 
                    (i->cityB == current_city && i->cityA == destination))
                {
                    i++;
                }
                else
                    i = exits.erase(i);
            }
            if(!exits.size())
                continue;
            int minc = exits[0].cost + (rand() % 9);
            unsigned int mini = 0;
            for(unsigned int i = 1; i < exits.size(); i++)
            {
                int myc = exits[i].cost + (rand() % 9);
                if(myc < minc || rand() % 10 == 0)
                {
                    minc = myc;
                    mini = i;
                }
            }
            
            next_step = exits[mini];
        }
    }
}
