#include "resources.h"
#include "log.h"
#include <fstream>
#include <sstream>
using namespace std;

void Resources::load(const string &filename)
{
    resources.clear();
    
    string line, str;
    
    ifstream in(filename.c_str());
    
    getline(in, line);
    
    if(line.find("resourceDb") != 0)
        throw "Invalid resourceDb file";
    
    unsigned int i = line.find("v");
    
    if(i == string::npos)
        throw "Unable to find version number in resourceDb file";
    
    int ver = 0;
    
    istringstream verss(line.substr(i));
    
    verss.ignore();
    
    verss >> ver;
    
    if(ver != 1)
        throw "Invalid version number for resourceDb file";
    
    while(in.good()) {
        
        getline(in, line);
        
        istringstream data(line);
        
        unsigned int id = 0;
        
        data >> id;
        
        if(id) {
            
            Resource &resource = resources[id];
            
            data >> resource.name;
            
            while(data.good()) {
                
                data >> str;
                resource.descr += str + " ";
            }
        }
    }
    
    out << "Loaded resourceDb, resources: " << resources.size() << "\n";
}
