#include "splashscreen.h"
#include "software.h"
#include "conf.h"
using namespace std;

SplashScreen::SplashScreen()
    : tint(.3, .3, .3), rotation(.5), fadingIn(1), logo("logos/allegro/")
{
    input.requestKeycode(KEY_ENTER);
    input.requestKeycode(KEY_SPACE);
    input.requestKeycode(KEY_ESC);
    input.requestKeycode(KEY_ENTER_PAD);
}

SplashScreen::~SplashScreen()
{
    
}

void SplashScreen::draw()
{
    Bitmap *bmp = logo.get_bmp();
    
    if(bmp)
        bmp->specialBlitToScreen(640 / 2 - bmp->getw() / 2, 480 / 2 - bmp->geth() / 2, 1, 1, rotation, tint);
    else
        throw "Unable to load logo.";
    
    globalConfInstance->flip();
}

SplashScreen::Options SplashScreen::think(Gui&)
{
    float diff = -.01;
    
    if(input.keycodeWaiting() || mouse_b) {
        
        diff = -.05;
        fadingIn = false;
    }
    
    if(fadingIn) {
        
        diff = -diff;
        
        if((tint.r > 2 && !rotation) || (tint.r > 1 && rotation))
            fadingIn = false;
    }
    
    tint.r += diff;
    tint.g += diff;
    tint.b += diff;
    
    if(tint.r < .3)
        if(!rotation)
            return END;
        else {
            
            tint.r = .3;
            tint.g = .3;
            tint.b = .3;
            fadingIn = true;
            rotation = 0;
        }
    
    return CONTINUE;
}
