#include "trains.h"
#include <log.h>
#include <fstream>
#include <sstream>
using namespace std;

void Trains::load(const string &filename)
{
    trains.clear();
    
    string line, str;
    
    ifstream in(filename.c_str());
    
    getline(in, line);
    
    if(line.find("trainDb") != 0)
        throw "Invalid trainDb file";
    
    unsigned int i = line.find("v");
    
    if(i == string::npos)
        throw "Unable to find version number in trainDb file";
    
    int ver = 0;
    
    istringstream verss(line.substr(i));
    
    verss.ignore();
    
    verss >> ver;
    
    if(ver != 1)
        throw "Invalid version number for trainDb file";
    
    while(in.good()) {
        
        getline(in, line);
        
        istringstream data(line);
        
        unsigned int id = 0;
        
        data >> id;
        
        if(id) {
            
            Train &train = trains[id];
            
            data >> train.passengerLimit;
        }
    }
    
    out << "Loaded trainDb, trains: " << trains.size() << "\n";
}
