#include "user.h"
#include "checksum.h"
#include "world.h"
#include "log.h"
using namespace std;

void User::setPass(const string &pass)
{
    password = checksum(pass.c_str(), pass.size());
}

bool User::checkPass(const string &pass)
{
    return password == checksum(pass.c_str(), pass.size());
}

void User::setUsername(string name)
{
    for(string::iterator itr = name.begin(); itr != name.end(); ++itr) {
        
        *itr = tolower(*itr);
    }
    
    username = name;
}

bool User::checkUsername(string name)
{
    for(string::iterator itr = name.begin(); itr != name.end(); ++itr) {
        
        *itr = tolower(*itr);
    }
    
    return name == username;
}

int User::useItem(unsigned int item, int count)
{
    int &size = items[item];
    
    if(count > size)
        count = size;
    
    size -= count;
    
    return count;
}

int User::giveItem(unsigned int item, int count)
{
    int &size = items[item];
    int spaces = getItemSpace();
    
    if(spaces > 0 && count > 0)
        while(world.itemDb.items[item].inventorySize * count > spaces)
            count--;
    
    size += count;
    
    return count;
}

int User::getItemSpace()
{
    int space = 100;
    
    for(Items::iterator itr = items.begin(); itr != items.end(); ++itr)
        space -= world.itemDb.items[itr->first].inventorySize * itr->second;
    
    return space;
}
